package gssim.db.dao.data;

/**
 * 
 * @author Jarek Szymczak
 *
 */
public class Resource {

	protected Integer PK;
	protected Integer expId;
	protected String name;
	protected String type;
	protected Double allocationLoad;
	protected Double reservationLoad;
	
	public Integer getPK() {
		return PK;
	}
	
	public void setPK(Integer pK) {
		PK = pK;
	}
	
	public Integer getExpId() {
		return expId;
	}
	
	public void setExpId(Integer expId) {
		this.expId = expId;
	}
	
	public String getName() {
		return name;
	}
	
	public void setName(String name) {
		this.name = name;
	}
	
	public String getType() {
		return type;
	}
	
	public void setType(String type) {
		this.type = type;
	}
	
	public Double getAllocationLoad() {
		return allocationLoad;
	}
	
	public void setAllocationLoad(Double allocationLoad) {
		this.allocationLoad = allocationLoad;
	}
	
	public Double getReservationLoad() {
		return reservationLoad;
	}
	
	public void setReservationLoad(Double reservationLoad) {
		this.reservationLoad = reservationLoad;
	}
	
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + PK;
		long temp;
		temp = Double.doubleToLongBits(allocationLoad);
		result = prime * result + (int) (temp ^ (temp >>> 32));
		result = prime * result + expId;
		result = prime * result + ((name == null) ? 0 : name.hashCode());
		temp = Double.doubleToLongBits(reservationLoad);
		result = prime * result + (int) (temp ^ (temp >>> 32));
		result = prime * result + ((type == null) ? 0 : type.hashCode());
		return result;
	}
	
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Resource other = (Resource) obj;
		if (PK != other.PK)
			return false;
		if (Double.doubleToLongBits(allocationLoad) != Double
				.doubleToLongBits(other.allocationLoad))
			return false;
		if (expId != other.expId)
			return false;
		if (name == null) {
			if (other.name != null)
				return false;
		} else if (!name.equals(other.name))
			return false;
		if (Double.doubleToLongBits(reservationLoad) != Double
				.doubleToLongBits(other.reservationLoad))
			return false;
		if (type == null) {
			if (other.type != null)
				return false;
		} else if (!type.equals(other.type))
			return false;
		return true;
	}
	
	@Override
	public String toString() {
		return "Resource [PK=" + PK + ", expId=" + expId + ", name=" + name
				+ ", type=" + type + ", allocationLoad=" + allocationLoad
				+ ", reservationLoad=" + reservationLoad + "]";
	}
}
