package gssim.db.mysql;

import gssim.db.dao.data.Configuration;
import gssim.db.find.Finder;
import gssim.db.utils.PreparedStatementAdapter;
import gssim.db.utils.ResultSetAdapter;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.List;

import org.apache.commons.logging.LogFactory;

import com.mysql.jdbc.NotImplemented;

public class ConfigurationDAO extends AbstractDAO implements
		gssim.db.dao.ConfigurationDAO {

	protected ConfigurationDAO(Connection conn) throws SQLException {
		super(conn);
		log = LogFactory.getLog(ConfigurationDAO.class);
		setRelationName("configuration");
	}

	@Override
	protected PreparedStatementAdapter createDeleteStmt() throws SQLException {
		return null;
	}

	@Override
	protected PreparedStatementAdapter createFindStmt() throws SQLException {
		return null;
	}

	@Override
	protected PreparedStatementAdapter createInsertStmt() throws SQLException {
		String sql = "INSERT INTO configuration VALUES (null);";
		PreparedStatementAdapter stmt = new PreparedStatementAdapter(this
				.getConnection().prepareStatement(sql,
						Statement.RETURN_GENERATED_KEYS));

		return stmt;
	}

	@Override
	protected PreparedStatementAdapter createSelectStmt() throws SQLException {
		String sql = "SELECT * FROM configuration WHERE id = ?";
		PreparedStatementAdapter stmt = new PreparedStatementAdapter(this
				.getConnection().prepareStatement(sql));
		return stmt;
	}

	@Override
	protected PreparedStatementAdapter createUpdateStmt() throws SQLException {
		return null;
	}

	@Override
	public boolean delete(Configuration obj, boolean commit)
			throws SQLException {
		throw new NotImplemented();
	}

	@Override
	public void fillObjectFromResultSet(Configuration obj, ResultSet result)
			throws SQLException {
		throw new NotImplemented();

	}

	@Override
	public int fillStatementWithObject(PreparedStatement stmt,
			Configuration obj, int offset) throws SQLException {
		throw new NotImplemented();
	}

	@Override
	public List<Configuration> find(Finder finder) throws SQLException {
		throw new NotImplemented();
	}

	@Override
	public int insert(Configuration obj, boolean commit) throws SQLException {

		PreparedStatementAdapter stmt = getInsertStmt();

		int result = stmt.executeUpdate();

		if (commit)
			commit();

		if (result == 1) {
			logSuccess("insert");

			ResultSet gk = stmt.getGeneratedKeys();
			int id = gk.next() ? gk.getInt(1) : -1;
			obj.setId(id);

		} else
			logError("insert", result, obj);

		return result;
	}

	@Override
	public int[] insertBatch(List<Configuration> objList, boolean commit)
			throws SQLException {
		throw new NotImplemented();
	}

	@Override
	public Configuration select(Configuration obj) throws SQLException {

		PreparedStatementAdapter stmt = getSelectStmt();
		stmt.setInt(1, obj.getId());
		ResultSetAdapter result = new ResultSetAdapter(stmt.executeQuery());

		result.next();
		boolean first = result.isFirst();
		boolean last = result.isLast();

		if (first && last) {
			return obj;
		}

		// no reservation found with specified task_id and allocation_id
		if (!first && !last) {
			return null;
		}

		// no idea how this may happen (only if id is not primary key)
		throw new SQLException("Select operation in relation "
				+ getRelationName() + " returned more than one record");
	}

	@Override
	public boolean update(Configuration obj, boolean commit)
			throws SQLException {
		throw new NotImplemented();
	}

}